#pragma once

#include <RobotAPI/interface/armem/server/LoadingMemoryInterface.ice>
#include <RobotAPI/interface/armem/server/StoringMemoryInterface.ice>

#include <RobotAPI/interface/armem/server/ReadingMemoryInterface.ice>
#include <RobotAPI/interface/armem/server/WritingMemoryInterface.ice>

#include <RobotAPI/interface/armem/client/MemoryListenerInterface.ice>


module armarx
{
    module armem
    {
        module server
        {
            interface LongTermMemoryInterface extends LoadingMemoryInterface, StoringMemoryInterface
            {
            };

            interface WorkingMemoryInterface extends ReadingMemoryInterface, WritingMemoryInterface
            {
            };

            interface MemoryInterface extends
                    WorkingMemoryInterface,
                    LongTermMemoryInterface,
                    client::MemoryListenerInterface
            {
            };
        };
    };
};
