#include <RobotAPI/libraries/armem/client/ReaderComponentPlugin.h>


// ArmarX
#include <ArmarXCore/core/Component.h>
#include <ArmarXCore/core/exceptions/local/ExpressionException.h>

// RobotAPI
#include <RobotAPI/libraries/armem/core/error.h>


namespace armarx::armem::client::plugins
{
    ReaderComponentPlugin::ReaderComponentPlugin(ManagedIceObject& parent, std::string pre) :
        ComponentPlugin(parent, pre)
    {
        addPlugin(mnsPlugin, pre);
        addPluginDependency(mnsPlugin);
    }


    ReaderComponentPlugin::~ReaderComponentPlugin()
    {
    }
}



namespace armarx::armem::client
{
    ReaderComponentPluginUser::ReaderComponentPluginUser()
    {
        addPlugin(plugin);
    }


    ReaderComponentPluginUser::~ReaderComponentPluginUser()
    {
    }


    void
    ReaderComponentPluginUser::setReadingMemoryServer(server::ReadingMemoryInterfacePrx memory)
    {
        memoryReader.setReadingMemory(memory);
    }

}
