#pragma once

#include <RobotAPI/libraries/aron/core/navigator/type/forward_declarations.h>


namespace armarx::armem::base::detail
{

    /**
     * @brief Something with a specific ARON type.
     */
    class AronTyped
    {
    public:

        explicit AronTyped(aron::typenavigator::ObjectNavigatorPtr aronType = nullptr);


        bool hasAronType() const;
        aron::typenavigator::ObjectNavigatorPtr& aronType();
        aron::typenavigator::ObjectNavigatorPtr aronType() const;


    protected:

        /// The expected Aron type. May be nullptr, in which case no type information is available.
        aron::typenavigator::ObjectNavigatorPtr _aronType;

    };


}
